#!/usr/bin/perl
use Tk;
use strict;

#
# Definition des Hauptfensters
#
my $mainw = new MainWindow(-title => "Internet status");
my $frame = $mainw->Frame(-relief => "groove",
    -borderwidth => "2")->pack(-padx => 5, -pady => 5);

our $label_1 = $frame->Label(-text => 'ISDN 1', -borderwidth => 2, -relief => 'sunken');
$label_1->pack(-side => "left", -padx => 5);

our $label_2 = $frame->Label(-text => 'ISDN 2', -borderwidth => 2, -relief => 'sunken');
$label_2->pack(-side => "left", -padx => 5);


# initialen Status ermitteln
get_status();
$mainw->repeat(1000, \&get_status); # Jede Sekunde den Status neu prfen

my $frame2 = $mainw->Frame(-relief => "groove",
    -borderwidth => "2")->pack(-padx => 5, -pady => 5);
my $connect_button = $frame2->Button(-text => "Verbinden",
    -command => \&connect )->pack(-side => 'left');
my $diconnect_button = $frame2->Button(-text => "Trennen",
    -command => \&disconnect )->pack(-side => 'left');


MainLoop();


#
# Subroutinen, welche von den Buttons und dem Fenster aufgerufen werden
#
sub get_status {
	# var init
	my $offline_color = '#f00000';
	my $online_color = '#00f000';

	my $l1_col;
	my $l2_col;

	# status mit ifdata ermitteln:
	my $l1_status = `ifdata -pe ppp0`;
	my $l2_status = `ifdata -pe ppp1`;
	chomp $l1_status; chomp $l2_status;

	# farben und text ermitteln
	print STDERR "STATUS: LINE1=$l1_status LINE2=$l2_status\n";
	if ($l1_status =~ /yes/) {
		$l1_col  = $online_color;
	} else {
		$l1_col  = $offline_color;
	}

	if ($l2_status =~ /yes/) {
		$l2_col  = $online_color;
	} else {
		$l2_col  = $offline_color;
	}

	# label updaten
	$label_1->configure(-background => $l1_col);
	$label_2->configure(-background => $l2_col);
}

sub connect {
	print STDERR "connecting...\n";
	`pon arcor_tag`;
}

sub disconnect {
	print STDERR "disconnecting...\n";
	`poff -a`;
}
